from Observable import Observable
import desktop

import gtk
import os



#
# Class for reporting when the wallpaper image has changed.
#
class BGWatcher(Observable):

    OBS_CHANGE_BG = 0



    def __init__(self):

        self.__old_bg = 0

        gtk.timeout_add(50, self.__check_bg)



    def __check_bg(self):

        try:
            id = desktop.get_wallpaper_id()
            if (id != self.__old_bg):
                self.update_observer(self.OBS_CHANGE_BG)

            self.__old_bg = id

        except StandardError, e:
            if (self.__old_bg):
                self.update_observer(self.OBS_CHANGE_BG)
                self.__old_bg = 0

        return gtk.TRUE
